--Current Memory Load:380
--Quick Find Contents
---[SVARS]Saved Variables, Per Character
---[GVARS] Global Variables
--[[INITIALIZERS]]--
---[PLOAD] Loading Action
---[EVENT] Event Handler
---[UISET] Initial UIObject Setup
--[[UPDATERS]]--
---[UPDUI] Update UI Frame
---[UPDST] Update Skill Table
---[TIERS] Checks the index against the table to return the skill tier of a profession (i.e. Apprentice, master, etc.)
--[[COMMANDS]]--
---[SCMDS] /Commands
--[[PARSERS]]--
---[PARSE] Parser
---[MPARS] Multi-Parameter Command Parser
--[[CONFIG TOOLS]]--
---[CONFG]Sets the configuration mode of the frame as on/off
---[TCONF] Config mode toggle
--[[TRACKERS]]--
---[TRBAR] Sets a bars tracking to on or off
---[TBSET] command based bar tracking setter
---[TRALL] Set all bars to track
--[[FRAME MODIFIERS]]--
---[SCALE] Scales the Frame
---[ADJST] Adjusts the Frames Anchor after dragging to center based anchor
---[NUDGE] Move frame a small amount
---[RESET] Reset the UI
--[[UI INTERACTION]]--
---[HOVER] OnEnter/Onleave functions for Icons and Bars
--[[SUPPORT FUNCTIONS]]--
---[IDXOF] Returns the array index of the triggering item
---[PRINT] for quick printing from the XML

--[SVARS]Saved Variables, Per Character
PH_MODE 			= 0; 		--0:Short 		1:Long
PH_LOCK 			= 0;		--0:unlocked	1:locked
PH_VISIBLE 			= 1;		--0:not vis		1:vis
PH_LINK 			= 1;		--0:plain		1:show links
PH_EXPAND_DIRECTION = -1;		--1:up		   -1:down
PH_FIRSTRUN 		= true;		--if this is first run
PH_CONFIGMODE 		= false;	--in Config Mode?
PH_SCALE = {					--Archive the Frame Scale
		current 	= 1.00, 	--current scale
		min 		= 0.50,		--min scale
		max 		= 4.00		--max scale
};
PH_LOCUS = {					--Archive the Frame Location
		rp 			= "CENTER",	--relativePoint
		x 			= 0,		--xOffset
		y 			= 0			--yOffset
};
PH_TRACKING = {					--Default all On
		[1] 		= true,
		[2] 		= true,
		[3] 		= true,
		[4] 		= true,
		[5] 		= true,
		[6] 		= true
};
--Slash Commands
SLASH_ProfessionHUD1, SLASH_ProfessionHUD2 = '/ph', '/ProfessionHUD';	--/Commands
--[GVARS] Global Variables
--Text Color Constants
White  				= "|cffffffff";
Red    				= "|cffff0000";
Green  				= "|cff00ff00";
Blue   				= "|cff6060ff";
Cyan   				= "|cff00ffff";
Magenta				= "|cffff00ff";
Yellow 				= "|cffffff00";
--Bar State Colors
SKILLMAXNEARCOLOR	= {r = 1.00, g = 0.00, b = 0.00};
SKILLNORMALCOLOR	= {r = 0.25, g = 0.25, b = 0.75};
SKILLCAPCOLOR 		= {r = 0.25, g = 0.75, b = 0.25};
--Global Variables
Version		 		= {Major = 5, Minor = 6, Build = 3};
FullVersion			= Version.Major.."."..Version.Minor.."."..Version.Build
VariablesLoaded 	= false;
LinkTemplate 		= "\124cffffd000\124Henchant:SPELL\124h[SKILL: NAME]\124h\124r"
FrameUI 			= {Slider = nil, Edit = nil, XToggle = nil};
CollectionTerm 		= {};
Profession 			= {};
ProfessionNameSlot 	= {};
SKILLCAPMSG 		= "Skill At Max Level";
SKILLMAXMSG 		= "Seek Training";
--Current Skill Cap
SKILLCAP 			= 525;

--[[INITIALIZERS]]--
--[PLOAD] Loading Action
function ProfessionHUD_OnLoad(self)
	self:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b);
	self:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("CHAT_MSG_SKILL");
	self:RegisterEvent("CHAT_MSG_SYSTEM");
	self:RegisterEvent("PLAYER_TALENT_UPDATE");
	self:RegisterEvent("LEARNED_SPELL_IN_TAB");
	self:RegisterEvent("SPELLS_CHANGED");
	self:RegisterEvent("TRAINER_UPDATE");
	self:RegisterEvent("SKILL_LINES_CHANGED");
	self:RegisterEvent("VARIABLES_LOADED")
end

--[EVENT] Event Handler
function ProfessionHUD_OnEvent(self, event, ...)
	-- Starts the addon
	if (event == "ADDON_LOADED") then
		local addon = select(1, ...);
		if (addon == "ProfessionHUD") then
			DEFAULT_CHAT_FRAME:AddMessage(Green.."ProfessionHUD "..Red..FullVersion..Green..": Loaded. Type "..Cyan.."/ph"..Green.." for help.");
			PH_Initialize();
		end
		return;
	--Fires on Skill Up
	elseif (event == "CHAT_MSG_SKILL" or event == "CHAT_MSG_SYSTEM") then
		msg = ...
		PH_Parser(msg, event);
		PH_UpdateUI();
	--Fires on other update events
	elseif (event == "SPELLS_CHANGED" or 
			event == "LEARNED_SPELL_IN_TAB" or 
			event == "TRAINER_UPDATE" or
			event =="SKILL_LINES_CHANGED" or 
			event == "PLAYER_TALENT_UPDATE" 
			) then
		PH_UpdateUI();
	elseif (event == "VARIABLES_LOADED") then
		VariablesLoaded = true;
		PH_UpdateUI();
	end
end

--[UISET] Initial UIObject Setup
function PH_Initialize()
	for i =1,6 do	
		UIObject[i].bar = CreateFrame("StatusBar", nil, ProfessionHUD, "BarTemplate");
		UIObject[i].bar:SetPoint("TOPLEFT", ProfessionHUD, "TOPLEFT", 53, -(i * 23 - 14));
		UIObject[i].icon1 =  CreateFrame("Button", nil, UIObject[i].bar, "IconTemplate");
		UIObject[i].icon1:SetPoint("RIGHT", UIObject[i].bar, "LEFT", -5, 0);
		UIObject[i].icon2 =  CreateFrame("Button", nil, UIObject[i].icon1, "IconTemplate");
		UIObject[i].icon2:SetPoint("RIGHT", UIObject[i].icon1, "LEFT", -2, 0);
		UIObject[i].check = CreateFrame("CheckButton", nil, UIObject[i].bar, "CheckTemplate");
		UIObject[i].check:SetPoint("Left", UIObject[i].bar, "RIGHT");
		UIObject[i].bar.Text:SetText("[Not Learned]");
	end
	FrameUI.XToggle = CreateFrame("Button", nil, ProfessioonHUD, "RedButtonTemplate");
	FrameUI.XToggle:SetPoint("BOTTOM", ProfessionHUD, "BOTTOM", 0, 65)
	FrameUI.XToggle:SetFrameStrata("HIGH");
	FrameUI.Slider = CreateFrame("Slider", "ScaleSlide", ProfessionHUD, "SliderTemplate");
	FrameUI.Slider:SetPoint("BOTTOM", ProfessionHUD, "BOTTOM", -20, 15);
	FrameUI.Slider:SetMinMaxValues(PH_SCALE.min, PH_SCALE.max);
	FrameUI.Edit = CreateFrame("EditBox", "ScaleEdit", ProfessionHUD, "EditTemplate");
	FrameUI.Edit:SetPoint("BOTTOMRIGHT", ProfessionHUD, "BOTTOMRIGHT", -5, 20);
	ProfessionHUD:SetPoint("CENTER", UIParent, PH_LOCUS.rp, PH_LOCUS.x, PH_LOCUS.y);
	PH_SetScale(PH_SCALE.current);
	PH_SetConfigMode(false);
	PH_Adjust();
end

--[[UPDATERS]]--
--[UPDUI] Update UI Frame
function PH_UpdateUI()
	if(not VariablesLoaded) then
		return
	end
	PH_UpdateTable();
	local counter = 0;
	for i = 1, 6 do
		if(Profession[i].id ~= nil and Profession[i].id ~= 0) then
			--Setup Icon 1
			UIObject[i].icon1:Show();
			UIObject[i].icon1:SetBackdrop({bgFile=UIObject[i].tex1});
			UIObject[i].icon1:SetAttribute("type", "spell");
			--redirect mining link to smelting
			if(Profession[i].name1 == "Mining") then
				UIObject[i].icon1:SetAttribute("spell", "Smelting");
			else
				UIObject[i].icon1:SetAttribute("spell", Profession[i].name1);
			end
			local _,_,_,_, numskills = GetProfessionInfo(Profession[i].id)
			--Setup Icon2 if available
			if (numskills == 2) then
				UIObject[i].icon2:Show();
				UIObject[i].icon2:SetBackdrop({bgFile=UIObject[i].tex2});
				UIObject[i].icon2:SetAttribute("type", "spell");
				UIObject[i].icon2:SetAttribute("spell", Profession[i].name2);
			else
				UIObject[i].icon2:Hide();
			end
			--Set Bar Values
			UIObject[i].bar:SetMinMaxValues(0,Profession[i].max);
			UIObject[i].bar:SetValue(Profession[i].rank);
			--Format Bar Color
			if(Profession[i].rank >= Profession[i].max - 25 and Profession[i].rank < SKILLCAP and Profession[i].max < SKILLCAP) then
				UIObject[i].bar:SetStatusBarColor(SKILLMAXNEARCOLOR.r, SKILLMAXNEARCOLOR.g, SKILLMAXNEARCOLOR.b);
			elseif (Profession[i].rank == SKILLCAP) then
				UIObject[i].bar:SetStatusBarColor(SKILLCAPCOLOR.r, SKILLCAPCOLOR.g, SKILLCAPCOLOR.b);
			else
				UIObject[i].bar:SetStatusBarColor(SKILLNORMALCOLOR.r, SKILLNORMALCOLOR.g, SKILLNORMALCOLOR.b);
			end
			--Format Bar Text
			if(PH_MODE == 0) then
				UIObject[i].bar.Text:SetText(Profession[i].name1);
			else
				UIObject[i].bar.Text:SetText(Profession[i].name1.." ["..Profession[i].rank.."/"..Profession[i].max.."]");	
			end
			PH_TrackBar(i, true);
			counter = counter + 1;
		else
			local _, max = UIObject[i].bar:GetMinMaxValues();
			PH_TrackBar(i, false);
			UIObject[i].bar.Text:SetText("[Not Learned]");
			UIObject[i].bar:SetStatusBarColor(SKILLNORMALCOLOR.r, SKILLNORMALCOLOR.g, SKILLNORMALCOLOR.b);
			UIObject[i].bar:SetValue(max);
			UIObject[i].icon1:Hide();
			UIObject[i].icon2:Hide(); 			
		end
	end
	--Adjust visibility if not visible or has no bars
	if (counter == 0 or PH_VISIBLE == 0) then
		ProfessionHUD:Hide();
	else
		ProfessionHUD:Show();
	end
end

--[UPDST] Update Skill Table
function PH_UpdateTable()
	for i = 1,6 do
		--Searches for reversed skills(i.e. skill is top button, buff is bottom)
		local text1 = ProfessionNameSlot[i]:GetText()
		local text2 = ProfessionNameSlot[i + 6]:GetText()
		if (text2 == "Skinning") then
			text2 = text1
			text1 = "Skinning"
		end
		if (text1 ~= nil) then --Gets spell information from name
			Profession[i].name1,_,UIObject[i].tex1 = GetSpellInfo(text1)
		end
		
		if (text2 ~= nil) then --Gets spell information from name
			Profession[i].name2,_,UIObject[i].tex2 = GetSpellInfo(text2)
		end
		
	end
	Profession[1].id, Profession[2].id, Profession[3].id, Profession[4].id, Profession[5].id, Profession[6].id= GetProfessions()
	for i = 1, 6 do
		if(Profession[i].id ~= nil) then
			local numskills
			Profession[i].name1, UIObject[i].tex1, Profession[i].rank, Profession[i].max, numskills = GetProfessionInfo(Profession[i].id);
			Profession[i].spell1 = PH_GetSkillTier(Profession[i].name1)
			if (numskills == 2) then
				Profession[i].spell2 = PH_GetSkillTier(Profession[i].name2)
			end
		else
			Profession[i].name1, Profession[i].rank, Profession[i].max, Profession[i].spell1, Profession[i].name2, Profession[i].spell2 = 0, 0, 0, 0, 0, 0
		end
	end
	--PH_UpdateUI();
end

--[TIERS] Checks the index against the table to return the skill tier of a profession (i.e. Apprentice, master, etc.)
function PH_GetSkillTier(name)
	local tier = 0
	local index = 0
	local prof = nil
	if (name == "Toughness") then
		prof = "Mining"
	elseif (name == "Lifeblood") then
		prof = "Herbalism"
	elseif (name == "Master of Anatomy") then
		prof = "Skinning"
	elseif (name == "Elixer Master")then
		return 28677
	elseif (name == "Potion Master")then
		return 28675
	elseif (name == "Transmutation Master")	then
		return 28672
	elseif (name == "Goblin Engineer")then
		return 20222
	elseif (name == "Gnomish Engineer")then
		return 20219
	elseif (name == "Milling")then
		return 51005
	elseif (name == "Prospecting")then
		return 31252
	elseif (name == "Northern Cloth Scavenging")then
		return 59390
	elseif (name == "Survey")then
		return 80451
	elseif (name == "Cooking Fire")then
		return 818
	elseif (name == "Disenchant") then
		return 13262
	elseif (name == nil or name == 0) then
		return -1
	end
	for i = 1, 6 do
		if(Profession[i].name1 == name or Profession[i].name1 == prof or Profession[i].name2 == name or Profession[i].name2 == prof) then
				index = i
				break
		end
	end
	for i = 1, 8 do
		if (name == "Lifeblood") then
			if(Profession[index].rank >= ((i - 1) * 75)) then
				tier = i
			end
		elseif (name == "Toughness" or name == "Master of Anatomy") then
			if(Profession[index].rank >= (i * 75)) then
				tier = i
			end
		else
			if ((Profession[index].max >= (i * 75)) and (Profession[index].max <= (i * 75) + 15)) then
				tier = i
				break
			end
		end
	end
	return SkillTier[name][tier]
end

--[[COMMANDS]]--
--[SCMDS] /Commands
function SlashCmdList.ProfessionHUD(msg)
	local param = {};
	msg, param = PH_MultCmdParse(msg);
	local later = Green.."ProfessionHUD:"..Red.." This Command Will Be Active Later";
	if (msg == 'mode' or msg =='toggle') then 
		if (PH_MODE == 0) then 
			PH_MODE = 1;
			print(Green.."ProfessionHUD:"..Cyan.." Long Mode On.");
		else
			PH_MODE = 0
			print(Green.."ProfessionHUD:"..Cyan.." Short Mode On.");
		end
		PH_UpdateUI();
	elseif (msg == 'hide') then
		print(Green.."ProfessionHUD:"..Cyan.." Hiding.");
		PH_SetConfigMode(false);
		ProfessionHUD:Hide();
		PH_VISIBLE = 0;
	elseif (msg == 'show') then
		local learned, tracking = 6, 6;
		for i = 1,6 do
			if (Profession[i].id == nil) then
				learned = learned - 1;
			end
			if (PH_TRACKING[i] == false) then
				tracking = tracking - 1;
			end
		end
		if (learned == 0) then
			print(Green.."ProfessionHUD:"..Red.." No Skills To Show.");
		elseif (tracking == 0) then
			print(Green.."ProfessionHUD:"..Red.." No Skills Being Tracked. Switching To Config Mode.");
			PH_SetConfigMode(true);
		else
			PH_VISIBLE = 1;
			print(Green.."ProfessionHUD:"..Cyan.." Showing.");
			ProfessionHUD:Show();
		end
	elseif (msg == 'lock') then
		PH_LOCK = 1
		local wd,ht = ProfessionHUD:GetSize();
		if (wd > 224) then
			wd = 224;
			PH_Nudge(-13, 0);
		end
		ProfessionHUD:SetSize(wd, ht);
		ProfessionHUDFrame:StopMovingOrSizing();
		print(Green.."ProfessionHUD:"..Cyan.." Frame Locked.");
	elseif (msg == 'unlock') then
		PH_LOCK = 0
		print(Green.."ProfessionHUD:"..Cyan.." Frame Unlocked.");
	elseif (msg == 'prime' or msg == 'primary' or msg == 'pri') then
		print(Green.."ProfessionHUD:"..Cyan.." Showing Only Primary Skills.");
		PH_SetBar(msg, true);
	elseif (msg == 'sec' or msg== 'secondary') then
		print(Green.."ProfessionHUD:"..Cyan.." Showing Only Secondary Skills.");
		PH_SetBar(msg, true);
	elseif (msg == 'all') then
		print(Green.."ProfessionHUD:"..Cyan.." Showing All Skills.");
		PH_SetBar(msg, true);
	elseif (msg == 'reset') then
		print(Green.."ProfessionHUD:"..Cyan.." Resetting.");
		PH_Reset();
	elseif (msg == 'where') then
		print("["..Red.."Debug"..White.."] ");
		print(ProfessionHUD:GetPoint());
		print(ProfessionHUD:GetScale());
	elseif (msg == 'move') then
		local p, rt, rp, x, y = param[0], param[1], param[2], param[3], param[4];
		print(p..","..rt..","..rp..","..x..","..y);
		ProfessionHUD:ClearAllPoints();
		ProfessionHUD:SetPoint(p, rt, rp, x, y);
	elseif (msg == 'link') then
		print(Green.."ProfessionHUD:"..Cyan.." Attaching "..Yellow.."[Links]"..Cyan..".");
		PH_LINK = 1;
	elseif (msg == 'plain') then 
		print(Green.."ProfessionHUD:"..Cyan.." Detaching "..White.."Links"..Cyan..".");
		PH_LINK = 0;
	elseif (msg == 'config' or msg == 'cf') then
		PH_ToggleConfig();
	elseif (msg == 'refresh' or msg == 'rf') then
		PH_UpdateUI();
	elseif (msg == 'g' or msg == 'guide' or msg == 'p1') then
		print(" ")
		print(Green.."ProfessionHUD "..Version..Cyan.." New User's Guide")
		print(Cyan.."Somewhere on your screen, default at center, you will see the ProfessionHUD(PH) Frame.")
		print(Cyan.."This will show your currently known "..Green.."Professions"..Cyan..".")
		print(Cyan.."If you move your mouse over a bar, it will show your current and max skill.")
		print(Cyan.."Typing "..Green.."/ph mode"..Cyan.." or "..Green.."/ph toggle"..Cyan.." will show or hide the skill numbers.")
		print(Cyan.."While in Long Mode, putting your mouse over a bar will show your remaining points until your current maximum.")
		print(Yellow.."Type "..Green.."/ph p2"..Yellow.." for more.")
	elseif (msg == 'p2') then
		print(" ")
		print(Cyan.."Typing "..Green.."/ph unlock"..Cyan.." will allow you to click and drag the frame to anywhere you like.")
		print(Cyan.."Typing "..Green.."/ph lock"..Cyan.." will lock it in place.")
		print(Cyan.."Typing "..Green.."/ph hide"..Cyan.." or "..Green.."/ph show"..Cyan.." will hide and show the frame, respectively. The frame will not show if there are no skills to show.")
		print(Cyan.."The Icons beside the PH bars sybolize your "..Green.."Professions"..Cyan..". Clicking them will open the skill pane for that "..Green.."Profession"..Cyan..".")
		print(Red.."At this time, I cannot cast any skills, such as Lifeblood or Milling."..Cyan.." You will need to use the default buttons.")
		print(Yellow.."Type "..Green.."/ph p3"..Yellow.." for more.")
	elseif (msg == 'p3') then
		print(" ")
		print(Cyan.."When you "..Blue.."incease in a skill"..Cyan..", I will update the bars.")
		print(Cyan.."If your skill in a "..Green.."Profession"..Cyan.." raises to where you can learn a new skill "..Yellow.."from a trainer"..Cyan..", then I will let you know.")
		print(Cyan.."By default, I will "..Yellow.."link"..Cyan.." the new skills to your chat window.")
		print(Cyan.."Typing "..Green.."/ph plain"..Cyan.." will send the skill names in "..White.."plain text"..Cyan..".")
		print(Cyan.."Typing "..Green.."/ph link"..Cyan.." will return to "..Yellow.."link"..Cyan.."ed mode.")
		print(Yellow.."This concludes the guide. Have fun!")
	elseif (msg == 'track') then
		PH_TrackBarSet(param[0], true);
	elseif (msg == 'untrack') then
		PH_TrackBarSet(param[0], false);
	elseif (msg == 'xdir') then
		if (param[0] == 'up') then 
			PH_EXPAND_DIRECTION = 1;
		else
			PH_EXPAND_DIRECTION = -1;
		end
	elseif (msg == 'test') then
		print("for Testing purposes");
		PH_SetBarTexture("Frost");
	else
		print("ProfessionHUD: Usage");
		print(Green.."/ph "..Cyan.."[arg]");
		print(Green.."/ProfessionHUD "..Cyan.."[arg]");
		print(Yellow.."Args:");
		print(Cyan.." [g | guide] (Show An Explanation Of Features)");
		print(Green.." [help"..White.." or "..Cyan.. "[no arg]]"..White.." (Show This Menu)");
		print(Green.." [config"..White.." or "..Cyan.. "cf]"..White.." (Toggle Config Mode)");
		print(Green.." [refresh"..White.." or "..Cyan.. "rf]"..White.." (Refresh Frame)");
		print(Green.." [mode | toggle] "..White.."(Notation Mode Toggle)");
		print(Green.." [hide | show] "..White.."(Hide/Show Frame)");
		print(Green.." [lock | unlock] "..White.."(Lock/Unlock Frame)");
		print(Green.." [link | plain] "..White.."(Show New Skills As Links/Plain Text)");
		print(Green.." [track | untrack] #"..White.."(Tracks/Untracks the #th bar Of The 6)");
		print(Green.." [track inc] "..White.."(Tracks Only Incomplete Skills)");
		print(Green.." [reset] "..White.."(Resets Frame To Center)");
		print(Green.." [pri | prime | primary] "..White.."(Show Primary Skills Only)");
		print(Green.." [sec | secondary] "..White.."(Show Secondary Skills Only)");
		print(Green.." [all] "..White.."(Show All Skills)");
		print(Green.." [xdir up | down] "..White.."(Sets Frame Expansion Direction)");
		print(Red.."[NI]"..Green.." = Not Implemented.");
		print(Green.."End Of Commands");
	end
end

--[[PARSERS]]--
--[PARSE] Parser
function PH_Parser(msg, event)
	--Parse Skill Message
	local sub, find, len = string.sub, string.find, string.len
	local nys = "Not Yet Supported."
	if(event == "CHAT_MSG_SYSTEM") then
		--Unlearned
		if (find(msg,("You have unlearned")) ~= nil) then 
			if (not PH_CONFIGMODE) then
				PH_Nudge(0, -3.85 * PH_EXPAND_DIRECTION);
			end
			PH_SetConfigMode(PH_CONFIGMODE);
			
			return;
		end
	elseif(event == "CHAT_MSG_SKILL") then
		--Skill Learned
		if (find(msg,("You have gained the")) ~= nil) then
			--get the skill name
			local skillPos = find(msg, (" skill"));
			local learnedName = sub(msg, 21, skillPos);
			--Clear the secondary icon in preparation
			for i = 1, 6 do
				if(learnedName == Profession[i].name1) then
					PH_TrackBar(i, true);
				end
				UIObject[i].icon2:SetBackdrop({bgFile=nil});
			end
			if (not PH_CONFIGMODE) then
				PH_Nudge(0, 11.5 * PH_EXPAND_DIRECTION);
			end
			PH_UpdateUI()
			PH_SetConfigMode(PH_CONFIGMODE);
			return;
		end
		----Weed out riding
		local skillNameStart = find(msg, ("in "))
		local skillNameEnd = find(msg, (" has"))
		local skillNumStart = find(msg, ("to "))
		local lastSkill = sub(msg, skillNameStart+3, skillNameEnd-1)
		local skillNum = tonumber(sub(msg, skillNumStart + 3))
		--Scanning Chart For New Nodes/Skills
		local chart = {}
		local chartSize = 0
		if (lastSkill == "Skinning") then
			if (skillNum < 100) then
				if ((skillNum / 10) == floor(skillNum/10))then
					skillNum = floor((skillNum / 10) + 10)
					print(Green..CollectionTerm[lastSkill]..Yellow..skillNum);
					return
				end
			else
				if ((skillNum / 5) == floor(skillNum/5))then
					skillNum = floor(skillNum / 5)
					print(Green..CollectionTerm[lastSkill]..Yellow..skillNum)
					return
				end
			end
			return;
		else
			chart = Charts[lastSkill]
			chartSize = Sizes[chart]
		end
		--Print all nodes that match new rank
		local first = 0
		local swap = string.gsub
		for x = 1, chartSize do
			if(chart[x].Level == skillNum) then
				if (first == 0) then
					print(Blue..CollectionTerm[lastSkill])
					first = 1
				end
				if (lastSkill == "Mining" or lastSkill == "Herbalism" or lastSkill == "Skinning") then
					print(chart[x].Name)
				elseif (PH_LINK == 0) then
					local name = GetSpellInfo(chart[x].Spell)
					print(name)
				else 
					local message = LinkTemplate
					local name = GetSpellInfo(chart[x].Spell)
					message = swap(message, ("SPELL"), chart[x].Spell)
					message = swap(message, ("SKILL"), lastSkill)
					message = swap(message, ("NAME"), name)
					print(message)
				end
			elseif(chart[x].Level > skillNum) then 
				return;
			end
		end
	end
end

--[MPARS] Multi-Parameter Command Parser
function PH_MultCmdParse(msg)
	--handle empty msg
	if (msg == "") then
		return "";
	end
	local pos, size, main;
	local sub, find, len = string.sub, string.find, string.len;
	pos = find(msg, " ");
	if (pos == nil) then
		return msg; --handle single param commands
	end
	main = sub(msg, 0, pos - 1);
	size = len(msg);
	msg = sub(msg, pos + 1, size);
	local i = 0;
	local param = {};
	while ((msg ~= "") and (msg ~= " ") and (i < 30)) do
		pos = find(msg, " ");
		if (pos == nil) then
			param[i] = msg;
			break;
		else
			param[i] = sub(msg, 0, pos - 1);
			msg = sub(msg, pos + 1, size);
		end
		i = i + 1;
	end;
	return main, param;
end

--[[CONFIG TOOLS]]--
--[CONFG]Sets the configuration mode of the frame as on/off
function PH_SetConfigMode(configMode)
	local configHeight = 230;
	PH_UpdateTable();
	local count = 0;
	local wd, ht = ProfessionHUD:GetSize();
	if(configMode == true) then --Config Mode	input:true
		ProfessionHUD:Show();
		FrameUI.Slider:Show();
		FrameUI.Edit:Show();
		FrameUI.XToggle:Show();
		for i = 1, 6 do
			UIObject[i].bar:Show();
			UIObject[i].bar:SetPoint("TOPLEFT", ProfessionHUD, "TOPLEFT", 53, -(i * 23 - 14));
			UIObject[i].check:Show();
			PH_TrackBar(i, PH_TRACKING[i]);
		end
		if (not PH_CONFIGMODE) then
			PH_Nudge(10.5, (ht - configHeight) / 2);
		end
		ProfessionHUD:SetSize(245, configHeight);
		PH_CONFIGMODE = true;
	else						--Op Mode		input:false
		FrameUI.Slider:Hide();
		FrameUI.Edit:Hide();
		FrameUI.XToggle:Hide();
		for i = 1, 6 do
			if(PH_TRACKING[i]) then
				count = count + 1;
				UIObject[i].bar:Show();
				UIObject[i].bar:SetPoint("TOPLEFT", ProfessionHUD, "TOPLEFT", 53, -(count * 23 - 14));
			else
				UIObject[i].bar:Hide();
			end
			UIObject[i].check:Hide();
		end
		if(count == 0) then 
			ProfessionHUD:Hide();
		else
			--ProfessionHUD:Show();
		end
		local yNew = (count * 23) + 11;
		if (PH_CONFIGMODE) then
			PH_Nudge(-10.5, (ht - yNew) / 2);
		end
		ProfessionHUD:SetSize(224, yNew);
		PH_CONFIGMODE = false;
	end;
end

--[TCONF] Config mode toggle
function PH_ToggleConfig()
	PH_SetConfigMode(not PH_CONFIGMODE)
end

--[[TRACKERS]]--
--[TRBAR] Sets a bars tracking to on or off
function PH_TrackBar(index, track)
	if(not VariablesLoaded) then
		return;
	end
	if (track ~= true and track ~= false and track ~= nil and track ~= 1) then
		print("PHUD: TrackBar Error");
		return;
	elseif (track == 1) then
		track = true;
	elseif (track == nil) then
		track = false;
	end
	--Decide the alpha level
	local alpha = 1;
	if(track) then
		--Lock Unlearned skills from being tracked
		if (Profession[index].id == nil or Profession[index].id < 1) then
			UIObject[index].check:SetChecked(0);
			return;
		end
		alpha = 1;
		UIObject[index].check:SetChecked(1);
	else
		alpha = .2;
		UIObject[index].check:SetChecked(0);
	end
	PH_TRACKING[index] = track;
	--Set alpha
	UIObject[index].bar:SetAlpha(alpha);
end

--[TBSET] command based bar tracking setter
function PH_TrackBarSet(msg, track)
	if(not VariablesLoaded) then
		return;
	end
	local list = PH_TRACKING
	--check for user input number
	for i = 1, 6 do
		if(tonumber(msg) == i) then --is a number
			list[i] = track;
		elseif(msg == 'inc' or msg == 'incomplete') then
			if(Profession[i].id ~= nil and Profession[i].rank < 525) then
				list[i] = track;
			else 
				list[i] = not track;
			end;
		end
	end
	if(msg == 'pri' or msg == 'prime' or msg == 'primary') then
		list[1], list[2] = track, track;
	elseif (msg == 'sec' or msg == 'secondary') then
		list[3], list[4], list[5], list[6] = track, track, track, track;
	elseif (msg == 'all') then
		list[1], list[2], list[3], list[4], list[5], list[6] = track, track, track, track, track, track;
	end
	for i = 1, 6 do
		if(Profession[i].id ~= nil) then
			PH_TrackBar(i, list[i]);
			UIObject[i].check:SetChecked(list[i]);
		end
	end	
	PH_SetConfigMode(false);
	PH_UpdateUI();
end

--[TRALL] Set all bars to track
function PH_TrackAll()
	if(not VariablesLoaded) then
		return;
	end
	for i = 1, 6 do
		if(Profession[i].id ~= nil and Profession[i].id > 0) then
			PH_TRACKING[i] = true;
			PH_TrackBar(i, true);
			UIObject[i].check:SetChecked(1);
		else
			PH_TRACKING[i] = false;
			PH_TrackBar(i, false);
			UIObject[i].check:SetChecked(0);
		end
	end
	PH_SetConfigMode(false);
end

--[[FRAME MODIFIERS]]--
--[SCALE] Scales the Frame
function PH_SetScale(scale)
	--clamp scale
	if (scale > PH_SCALE.max) then
		scale = PH_SCALE.max;
	elseif (scale < PH_SCALE.min) then
		scale = PH_SCALE.min;
	end
	--update location to remain centered at current location
	local _, _, rp, x, y = ProfessionHUD:GetPoint();
	y = y * PH_SCALE.current / scale;
	x = x * PH_SCALE.current / scale;
	--update scale
	PH_SCALE.current = scale;
	ProfessionHUD:SetScale(scale);
	--update anchor
	ProfessionHUD:ClearAllPoints();
	ProfessionHUD:SetPoint("CENTER", "UIParent", rp, x, y)
	PH_LOCUS.rp, PH_LOCUS.x, PH_LOCUS.y = rp, x, y;
	--update UI controls
	FrameUI.XToggle:SetScale(scale/2);
	FrameUI.Slider:SetValue(scale);
	getglobal(FrameUI.Slider:GetName()..'Text'):SetText('Scale: '..string.format("%.2f", scale));
	FrameUI.Edit:SetText(string.format("%.2f", scale));
end

--[ADJST] Adjusts the Frames Anchor after dragging to center based anchor
function PH_Adjust()
	local p, _, rp, x, y = ProfessionHUD:GetPoint();
	local wd, ht = ProfessionHUD:GetSize();
	wd, ht = wd/2, ht/2;
	if ((rp == "TOP") or (rp == "TOPLEFT") or (rp == "TOPRIGHT")) then
		y = y - ht;
	elseif ((rp == "BOTTOM") or (rp == "BOTTOMLEFT") or (rp == "BOTTOMRIGHT")) then
		y = y + ht;
	end
	if ((rp == "LEFT") or (rp == "TOPLEFT") or (rp == "BOTTOMLEFT")) then
		x = x + wd;
	elseif ((rp == "RIGHT") or (rp == "TOPRIGHT") or (rp == "BOTTOMRIGHT")) then
		x = x - wd;
	end
	ProfessionHUD:ClearAllPoints();
	ProfessionHUD:SetPoint("CENTER", UIParent, rp, x, y);
end

--[NUDGE] Move frame a small amount
function PH_Nudge(xNew, yNew)
	local _,_, rp, x, y = ProfessionHUD:GetPoint();
	x, y = x + xNew, y + yNew;
	ProfessionHUD:ClearAllPoints();
	ProfessionHUD:SetPoint("CENTER", UIParent, rp, x, y);
end

--[RESET] Reset the UI
function PH_Reset()
	PH_TRACKING = {true,true,true,true,true,true};
	PH_FIRSTRUN = true;
	PH_MODE 			= 0;
	PH_LOCK 			= 0;
	PH_VISIBLE 			= 1;
	PH_LINK 			= 1;
	PH_EXPAND_DIRECTION = -1;
	PH_CONFIGMODE 		= false;
	PH_SCALE = {current	= 1.00, min = 0.50,	max	= 4.00};
	PH_LOCUS = {rp = "CENTER", x = 0, y = 0};
	ProfessionHUD:ClearAllPoints();
	ProfessionHUD:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
	if(VariablesLoaded) then
		PH_TrackAll();	
	end
	PH_SetConfigMode(false);
end

--[BRTEX] Bar Texture Modifier
function PH_SetBarTexture(name)
	print(BarTexturePath..name)
	for i = 1, 6 do
		UIObject[i].bar:SetStatusBarTexture(BarTexturePath..name)
	end
end

--[[UI INTERACTION]]--
--[HOVER] OnEnter/Onleave functions for Icons and Bars
--mouse entering bar
function PH_BarOnEnter(index)
	if ((Profession[index].id ~= nil) and (Profession[index].id ~= 0)) then
		if (PH_MODE == 0)then
			UIObject[index].bar.Text:SetText("["..Profession[index].rank.."/"..Profession[index].max.."]");
		else 
			if(Profession[index].rank == SKILLCAP) then
				UIObject[index].bar.Text:SetText(SKILLCAPMSG);
			elseif (Profession[index].rank == Profession[index].max) then
				UIObject[index].bar.Text:SetText(SKILLMAXMSG);
			else
				UIObject[index].bar.Text:SetText(Profession[index].max - Profession[index].rank.." Points Left");
			end
		end
	end
end

--mouse leaving bar
function PH_BarOnLeave(index)
	if ((Profession[index].id ~= nil) and (Profession[index].id ~= 0)) then
		if (PH_MODE == 0) then
			UIObject[index].bar.Text:SetText(Profession[index].name1);
		else
			UIObject[index].bar.Text:SetText(Profession[index].name1.." ["..Profession[index].rank.."/"..Profession[index].max.."]");
		end
	end
end

--mouse entering Icon
function PH_IconOnEnter(index1, index2)
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	local name;
	if (index2 == 1) then
		name = Profession[index1].name1;
	else
		name = Profession[index1].name2;
	end
	GameTooltip:SetSpellByID(PH_GetSkillTier(name));
	GameTooltip:Show()
end

--mouse leaving icon
function PH_IconOnLeave()
	GameTooltip:Hide()
end

--[[SUPPORT FUNCTIONS]]--
--[IDXOF] Returns the array index of the triggering item
function PH_IndexOf(self)
	for i =1,6 do
		if (self == UIObject[i].bar) or (self == UIObject[i].check) then
			return i;
		elseif (self == UIObject[i].icon1) then 
			return i, 1;
		elseif (self == UIObject[i].icon2) then
			return i, 2;
		end
	end
	return -1;
end

--[PRINT] for quick printing from the XML
function PH_Print(msg)
	print(msg);
end


